       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CALENDAR.
      *
      *    THIS PROGRAM IS A VARIATION OF ROGER COLE'S STANDARD
      *    CALENDAR PROGRAM.  IT AUTOMATICALLY GENERATES MOST
      *    SECULAR AND CHRISTIAN HOLIDAYS IF REQUESTED ON THE FIRST
      *    PARAMETER CARD
      *
       AUTHOR.          R ROGER COLE.
       DATE-WRITTEN.    JANUARY, 1974.
      *                 ORIGINALLY WRITTEN IN BURROUGHS B6700 COBOL
      *                 CONVERTED TO IBM COBOL - DECEMBER, 1984
      *                 CONVERTED TO COBOL650 FOR THE PC - DECEMBER 2002
       DATE-COMPILED.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT CARDIN            ASSIGN TO DISK
                                    ORGANIZATION IS LINE SEQUENTIAL.
           SELECT PRINTOUT          ASSIGN TO PRINTER.
           SELECT SORTFILE          ASSIGN TO DISK.
       DATA DIVISION.
       FILE SECTION.
       FD  CARDIN
           LABEL RECORDS ARE STANDARD
           VALUE OF FILE-ID IS "CALENDAR.INP".
       01  CARDIN-RECORD.
           03  PARAMETER-CARD.
               05  P-CK-WD             PIC X(05).
               05  PARAMETER-DATE.
                   10  CENTURY         PIC 9(02).
                   10  P-YR            PIC 9(02).
               05  DATE-NUMERIC REDEFINES PARAMETER-DATE.
                   10  NUM-DATE        PIC 9(04).
               05  FILLER              PIC X(01).
               05  FIRST-DAY           PIC 9(01).
               05  CALC-HOLIDAYS       PIC X(01).
               05  P-NAME              PIC X(20).
               05  REQ-MONTH           PIC X(02).
               05  EXTRA-PAGE-FLAG     PIC X(01).
               05  FILLER              PIC X(45).
           03  CALENDAR-CARD REDEFINES PARAMETER-CARD.
               05  MONTH-DAY.
                   10  MH              PIC 9(02).
                   10  DA              PIC 9(02).
               05  FILLER              PIC X(01).
               05  CARD-TEXT.
                   10  BLURBS.
                       15  BLURBIES OCCURS 4 TIMES.
                           20  BLURB       PIC X(15).
                           20  FILLER      PIC X(01).
                   10  FILLER              PIC X(02).
               05  FILLER                  PIC X(09).
       FD  PRINTOUT
           LABEL RECORDS ARE OMITTED.
       01  PRINTOUT-RECORD.
           03  PRINTOUT-TEXT.
               05  FILLER                  PIC X(07).
               05  CHARS OCCURS 20 TIMES.
                   10  LINE-CHAR           PIC X(05).
                   10  FILLER              PIC X(01).
               05  FILLER                  PIC X(05).
       SD  SORTFILE
           VALUE OF FILE-ID IS "CALENDAR.SRT".
       01  SORT-RECORD.
           05  SORT-KEY.
               10  SORT-JULIAN-DAY     PIC 9(03).
               10  SORT-CARD-IN        PIC 9(04).
               10  SORT-ORDER-FLAG     PIC 9(01).
           05  SORT-BLURB              PIC X(15).
           05  FILLER                  PIC X(01).
       WORKING-STORAGE SECTION.
       77  S1                          PIC S9(07) COMP-3 VALUE ZERO.
       77  S2                          PIC S9(07) COMP-3 VALUE ZERO.
       77  S3                          PIC S9(07) COMP-3 VALUE ZERO.
       77  S4                          PIC S9(07) COMP-3 VALUE ZERO.
       77  S10                         PIC S9(07) COMP-3 VALUE ZERO.
       77  S11                         PIC S9(07) COMP-3 VALUE ZERO.
       77  S12                         PIC S9(07) COMP-3 VALUE ZERO.
       77  SAVE-FIRST-DAY              PIC 9(01)  VALUE ZERO.
       77  SAVE-MO                     PIC 9(02)  VALUE ZERO.
       77  SAVE-WEEKDAY                PIC 9(01)  VALUE ZERO.
       77  CARDS-IN                    PIC S9(05) COMP-3 VALUE ZERO.
       77  JULIAN-HOLD                 PIC S9(03) COMP-3 VALUE ZERO.
       77  HOLD-NAME                   PIC X(20).
       77  HOLD-MONTH                  PIC 9(02).
       77  HOLD-EXTRA-PAGE-FLAG        PIC X(01).
       77  MO-SUB                      PIC 9(02)  VALUE ZERO.
       77  MAX-LINES-IN-BOX            PIC 9(02)  VALUE 06.
       77  PS-SUB                      PIC 9(02)  VALUE 01.
       77  PS-MAX                      PIC 9(02)  VALUE 05.
       77  LEFT-RIGHT                  PIC 9(02)  VALUE 01.
       77  PRINT-FLAG                  PIC X(01)  VALUE 'Y'.
       77  QUESTION-MARK               PIC X(01)  VALUE '?'.
       01  SAVE-PARAMETER-DATE.
           05  SPD-1                   PIC X(01).
           05  SPD-2                   PIC X(01).
           05  SPD-3                   PIC X(01).
           05  SPD-4                   PIC X(01).
       01  DAYS-OF-WEEK.
           05  FILLER  PIC X(01) VALUE SPACE.
           05  FILLER  PIC X(18) VALUE '      SUNDAY      '.
           05  FILLER  PIC X(18) VALUE '      MONDAY      '.
           05  FILLER  PIC X(18) VALUE '      TUESDAY     '.
           05  FILLER  PIC X(18) VALUE '     WEDNESDAY    '.
           05  FILLER  PIC X(18) VALUE '     THURSDAY     '.
           05  FILLER  PIC X(18) VALUE '      FRIDAY      '.
           05  FILLER  PIC X(18) VALUE '     SATURDAY     '.
       01  CALENDAR-LINE-1.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(18) VALUE
               '|-----------------'.
           05  FILLER                  PIC X(01) VALUE '|'.
       01  CALENDAR-LINE-2.
           05  LINE-2A.
               10  LINES-2 OCCURS 7 TIMES.
                   15  EDGE-2          PIC X(01).
                   15  FILLER-2A       PIC X(01).
                   15  LINE-2          PIC X(15).
                   15  FILLER-2B       PIC X(01).
           05  VERT-BAR                PIC X(01) VALUE '|'.
       01  DAY-LINE.
           05  FILLER                  PIC X(06) VALUE '   ** '.
           05  DY-NO                   PIC 9(02).
           05  FILLER                  PIC X(07) VALUE ' **    '.
       01  YR-LINE.
           05  FILLER                  PIC X(08) VALUE SPACES.
           05  YRS                     PIC 9(04).
           05  FILLER                  PIC X(08) VALUE SPACES.
       01  DATE-CONVERSION-TABLES.
           05  NON-LEAP-YEAR.
               10  FILLER  PIC 9(6)  VALUE 001031.
               10  FILLER  PIC 9(6)  VALUE 032059.
               10  FILLER  PIC 9(6)  VALUE 060090.
               10  FILLER  PIC 9(6)  VALUE 091120.
               10  FILLER  PIC 9(6)  VALUE 121151.
               10  FILLER  PIC 9(6)  VALUE 152181.
               10  FILLER  PIC 9(6)  VALUE 182212.
               10  FILLER  PIC 9(6)  VALUE 213243.
               10  FILLER  PIC 9(6)  VALUE 244273.
               10  FILLER  PIC 9(6)  VALUE 274304.
               10  FILLER  PIC 9(6)  VALUE 305334.
               10  FILLER  PIC 9(6)  VALUE 335365.
           05  LEAP-YEAR.
               10  FILLER  PIC 9(6)  VALUE 001031.
               10  FILLER  PIC 9(6)  VALUE 032060.
               10  FILLER  PIC 9(6)  VALUE 061091.
               10  FILLER  PIC 9(6)  VALUE 092121.
               10  FILLER  PIC 9(6)  VALUE 122152.
               10  FILLER  PIC 9(6)  VALUE 153182.
               10  FILLER  PIC 9(6)  VALUE 183213.
               10  FILLER  PIC 9(6)  VALUE 214244.
               10  FILLER  PIC 9(6)  VALUE 245274.
               10  FILLER  PIC 9(6)  VALUE 275305.
               10  FILLER  PIC 9(6)  VALUE 306335.
               10  FILLER  PIC 9(6)  VALUE 336366.
       01  WORKING-DATE-ARRAY.
           05  MONTHS OCCURS 12 TIMES.
               10  LOW-MONTH           PIC 9(03).
               10  HIGH-MONTH          PIC 9(03).
       01  OTHER-JUNK.
           05  DATE-HOLD               PIC 9(06).
           05  DATE-HOLD-REDEF REDEFINES DATE-HOLD.
               10  MO                  PIC 9(02).
               10  DY                  PIC 9(02).
               10  YR                  PIC 9(02).
           05  CURRENT-JULIAN-DAY      PIC 9(03).
           05  JULIAN-DAY              PIC 9(03).
           05  JULIAN-YEAR             PIC 9(02).
           05  WEEKDAY                 PIC 9(02).
       01  STORE-AREA.
           05  BLURBS-ACROSS OCCURS 7 TIMES.
               10  BLURBS-DOWN OCCURS 9 TIMES.
                   15  STORE-BLURB     PIC X(15).
       01  MONTH-ARRAY.
           05  MO-A.
               10  FILLER  PIC X(20) VALUE '   JANUARY - &*()   '.
               10  FILLER  PIC X(20) VALUE '   FEBRUARY - &*()  '.
               10  FILLER  PIC X(20) VALUE '    MARCH - &*()    '.
               10  FILLER  PIC X(20) VALUE '    APRIL - &*()    '.
               10  FILLER  PIC X(20) VALUE '     MAY - &*()     '.
               10  FILLER  PIC X(20) VALUE '     JUNE - &*()    '.
               10  FILLER  PIC X(20) VALUE '     JULY - &*()    '.
               10  FILLER  PIC X(20) VALUE '    AUGUST - &*()   '.
               10  FILLER  PIC X(20) VALUE '  SEPTEMBER - &*()  '.
               10  FILLER  PIC X(20) VALUE '   OCTOBER - &*()   '.
               10  FILLER  PIC X(20) VALUE '   NOVEMBER - &*()  '.
               10  FILLER  PIC X(20) VALUE '   DECEMBER - &*()  '.
           05  MO-B REDEFINES MO-A.
               10  MO-C OCCURS 12 TIMES.
                   15  MO-NAME         PIC X(20).
       01  FIVE-BY-SEVEN-MATRIX.
           05  A-5-X-7.
               10  FILLER  PIC X(20) VALUE '@     @     @     @ '.
               10  FILLER  PIC X(20) VALUE '    @@@    @@    @@ '.
               10  FILLER  PIC X(20) VALUE '   @@@@@   @@@   @@@'.
               10  FILLER  PIC X(20) VALUE '@@@@  @@@@@ @  @  @ '.
               10  FILLER  PIC X(20) VALUE '@   @ @ @  @  @  @ @'.
               10  FILLER  PIC X(20) VALUE '@@  @ @@ @@ @@ @  @@'.
               10  FILLER  PIC X(20) VALUE '@@@@@@@ @@@ @ @@ @@@'.
               10  FILLER  PIC X(20) VALUE '@@@ @ @ @@@@ @      '.
           05  B-5-X-7 REDEFINES A-5-X-7.
               10  COMBINATIONS OCCURS 32 TIMES.
                   15  COMBO           PIC X(05).
       01  MATRIX-PATTERNS.
           05  MAT-A.
               10  FILLER  PIC 9(14)  VALUE 32323232323232.
               10  FILLER  PIC 9(14)  VALUE 03181717251717.
               10  FILLER  PIC 9(14)  VALUE 13171713171713.
               10  FILLER  PIC 9(14)  VALUE 11170101011711.
               10  FILLER  PIC 9(14)  VALUE 13171717171713.
               10  FILLER  PIC 9(14)  VALUE 25010113010125.
               10  FILLER  PIC 9(14)  VALUE 25010113010101.
               10  FILLER  PIC 9(14)  VALUE 14010101241714.
               10  FILLER  PIC 9(14)  VALUE 17171725171717.
               10  FILLER  PIC 9(14)  VALUE 11030303030311.
               10  FILLER  PIC 9(14)  VALUE 05050505051711.
               10  FILLER  PIC 9(14)  VALUE 17161506151617.
               10  FILLER  PIC 9(14)  VALUE 01010101010125.
               10  FILLER  PIC 9(14)  VALUE 17262727171717.
               10  FILLER  PIC 9(14)  VALUE 17172127241717.
               10  FILLER  PIC 9(14)  VALUE 11171717171711.
               10  FILLER  PIC 9(14)  VALUE 13171713010101.
               10  FILLER  PIC 9(14)  VALUE 11171717271622.
               10  FILLER  PIC 9(14)  VALUE 13171713151617.
               10  FILLER  PIC 9(14)  VALUE 11170111051711.
               10  FILLER  PIC 9(14)  VALUE 25030303030303.
               10  FILLER  PIC 9(14)  VALUE 17171717171711.
               10  FILLER  PIC 9(14)  VALUE 17171717171803.
               10  FILLER  PIC 9(14)  VALUE 17171727272617.
               10  FILLER  PIC 9(14)  VALUE 17171803181717.
               10  FILLER  PIC 9(14)  VALUE 17171803030303.
               10  FILLER  PIC 9(14)  VALUE 25050403020125.
               10  FILLER  PIC 9(14)  VALUE 03070303030311.
               10  FILLER  PIC 9(14)  VALUE 11170508020125.
               10  FILLER  PIC 9(14)  VALUE 25050408051711.
               10  FILLER  PIC 9(14)  VALUE 08181625040404.
               10  FILLER  PIC 9(14)  VALUE 25011305051711.
               10  FILLER  PIC 9(14)  VALUE 12020113171711.
               10  FILLER  PIC 9(14)  VALUE 25050403020202.
               10  FILLER  PIC 9(14)  VALUE 11171711171711.
               10  FILLER  PIC 9(14)  VALUE 11171714050410.
               10  FILLER  PIC 9(14)  VALUE 11172427211711.
               10  FILLER  PIC 9(14)  VALUE 32323232323202.
               10  FILLER  PIC 9(14)  VALUE 32323232030302.
               10  FILLER  PIC 9(14)  VALUE 32323225323232.
           05  MAT-B REDEFINES MAT-A.
               10  MAT-C OCCURS 40 TIMES.
                   15  MAT-D OCCURS 7 TIMES.
                       20  MAT-CHAR    PIC 9(02).
       01  CHAR-POSITION-ARRAY.
           05  CH-A.
               10  FILLER              PIC X(40) VALUE
                   ' ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,-'.
           05  CH-B REDEFINES CH-A.
               10  CH-C OCCURS 40 TIMES.
                   15  CHAR-CK         PIC X(01).
       01  HOLD-MATRIX.
           05  HOLD-ACROSS OCCURS 20 TIMES.
               10  HOLD-DOWN OCCURS 7 TIMES.
                   15  HOLD-KEY       PIC 9(02).
       01  HOLD-WORD-ARRAY.
           05  H-WDS OCCURS 20 TIMES.
               10  H-CHAR              PIC X(01).
       01  INV-DATE-MSG.
           05  FILLER                  PIC X(01) VALUE SPACE.
           05  FILLER                  PIC X(13) VALUE 'INVALID DATE '.
           05  INV-CARD                PIC X(80).
       01  PASCHAL-MOON-TABLE.
           05  P-DTS.
               10  FILLER  PIC X(16) VALUE '0414040303230411'.
               10  FILLER  PIC X(16) VALUE '0331041804080328'.
               10  FILLER  PIC X(16) VALUE '0416040503250413'.
               10  FILLER  PIC X(16) VALUE '0402032204100330'.
               10  FILLER  PIC X(12) VALUE '041704070327'.
           05  P-DTS-REDEFINES       REDEFINES P-DTS.
               10  P-DATES           OCCURS 19 TIMES.
                   15  PASCHAL-MOON  PIC X(04).
       01  POSTSCRIPT-AREA.
           05  POSTSCRIPTS           OCCURS 5 TIMES.
               10  POSTSCRIPT        OCCURS 2 TIMES
                                     PIC X(66).
       PROCEDURE DIVISION.
       SORTIT SECTION.
       DO-THE-SORT.
           SORT SORTFILE ON ASCENDING KEY
               SORT-KEY
                   INPUT PROCEDURE IS INPUT-PROCEDURE
                       OUTPUT PROCEDURE IS OUTPUT-PROCEDURE THRU
                           OUTPUT-PROCEDURE-EXIT.
           STOP RUN.
       INPUT-PROCEDURE SECTION.
       OPEN-INPUT.
           MOVE SPACES TO POSTSCRIPT-AREA.
           OPEN INPUT CARDIN.
           OPEN OUTPUT PRINTOUT.
           READ CARDIN
               AT END DISPLAY 'NO CARDS INPUT'
               STOP RUN.
           IF (P-CK-WD = 'YEAR=')
               NEXT SENTENCE
                   ELSE
               DISPLAY 'INVALID PARAMETER CARD'
               STOP RUN.
           MOVE P-NAME TO HOLD-NAME.
           MOVE REQ-MONTH TO HOLD-MONTH.
           MOVE EXTRA-PAGE-FLAG TO HOLD-EXTRA-PAGE-FLAG.
           MOVE P-YR TO JULIAN-YEAR.
           MOVE PARAMETER-DATE TO SAVE-PARAMETER-DATE.
           IF (NUM-DATE NOT NUMERIC) OR (FIRST-DAY NOT NUMERIC) OR
              (FIRST-DAY > 7 OR < 1)
                  DISPLAY 'INVALID PARAMETER CARD'
                  STOP RUN.
           MOVE FIRST-DAY TO SAVE-FIRST-DAY.
           MOVE NUM-DATE TO YRS.
      *    IF ((JULIAN-YEAR MOD 4) = ZERO)  OLD BURROUGHS CODE
      *    DIVIDE JULIAN-YEAR BY 4 GIVING S11 REMAINDER S12. IBM CODE
           DIVIDE JULIAN-YEAR BY 4 GIVING S11.
           COMPUTE S12 = JULIAN-YEAR - (S11 * 4).
           IF  S12 = ZERO
               MOVE LEAP-YEAR TO WORKING-DATE-ARRAY
                   ELSE
               MOVE NON-LEAP-YEAR TO WORKING-DATE-ARRAY.
           IF  CALC-HOLIDAYS NOT = 'Y'
               GO TO READ-LOOP.
       COMPUTE-HOLIDAYS.
           MOVE SPACES TO CALENDAR-CARD.
      *
      *    COMPUTE EASTER AS FOLLOWS:
      *
      *    EASTER FALLS ON THE FIRST SUNDAY FOLLOWING THE ARBITRARY
      *    PASCHAL FULL MOON, WHICH DOES NOT NECESSARILY COINCIDE
      *    WITH A REAL OR ASTRONOMICAL FULL MOON.  THE PASCHAL FULL
      *    MOON IS CALCULATED BY ADDING 1 TO THE REMAINDER OBTAINED
      *    BY DIVIDING THE YEAR BY 19 AND APPLYING THE NUMBER OBTAINED
      *    AS THE SUBSCRIPT INTO THE PASCHAL MOON TABLE.  THUS, FOR
      *    THE YEAR 2000 THE KEY (OR SUBSCRIPT) IS 6 OR APRIL 18TH.
      *    SINCE APRIL 18TH IN THE YEAR 2000 IS A TUESDAY, EASTER
      *    SUNDAY IS APRIL 23RD.  *** CAUTION *** - IF THE PASCHAL
      *    FULL MOON FALLS ON A SUNDAY, EASTER IS THE FOLLOWING
      *    SUNDAY.  THE EARLIEST EASTER CAN FALL IS MARCH 23RD AND
      *    THE LATEST IS APRIL 25TH.
      *
      *    COMPUTE S2 = (JULIAN-YEAR MOD 19) + 1.  OLD BURROUGHS CODE
      *    DIVIDE JULIAN-YEAR BY 19 GIVING S11 REMAINDER S12. IBM CODE
           DIVIDE JULIAN-YEAR BY 19 GIVING S11.
           COMPUTE S12 = JULIAN-YEAR - (S11 * 19).
           COMPUTE S2 = S12 + 1
           MOVE PASCHAL-MOON (S2) TO MONTH-DAY.
           MOVE 'EASTER SUNDAY' TO BLURB (1).
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           PERFORM FIND-DAY-OF-WEEK.
           COMPUTE JULIAN-HOLD = (JULIAN-DAY + (8 - WEEKDAY)).
           MOVE JULIAN-HOLD TO JULIAN-DAY.
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    ASH WEDNESDAY IS EASTER - 46 DAYS
      *
           COMPUTE JULIAN-DAY = (JULIAN-HOLD - 46).
           MOVE 'ASH WEDNESDAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    PALM SUNDAY IS EASTER - 7 DAYS
      *
           COMPUTE JULIAN-DAY = (JULIAN-HOLD - 7).
           MOVE 'PALM SUNDAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    GOOD FRIDAY IS EASTER - 2 DAYS
      *
           COMPUTE JULIAN-DAY = (JULIAN-HOLD - 2).
           MOVE 'GOOD FRIDAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    ASCENSION DAY IS EASTER + 39 DAYS
      *
           COMPUTE JULIAN-DAY = (JULIAN-HOLD + 39).
           MOVE 'ASCENSION DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    PENTECOST IS EASTER + 49 DAYS
      *
           COMPUTE JULIAN-DAY = (JULIAN-HOLD + 49).
           MOVE 'PENTECOST' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    TRINITY SUNDAY IS EASTER + 56 DAYS
      *
           COMPUTE JULIAN-DAY = (JULIAN-HOLD + 56).
           MOVE 'TRINITY SUNDAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    NEW YEAR'S DAY IS JANUARY 1ST
      *
           MOVE '0101' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'NEW YEARS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    LINCOLN'S BIRTHDAY IS FEBRUARY 12TH
      *
           MOVE '0212' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'LINCOLNS B-DY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    VALENTINE'S DAY IS FEBRUARY 14TH
      *
           MOVE '0214' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'VALENTINES DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    WASHINGTON'S BIRTHDAY (TRADITIONAL) IS FEBRUARY 22ND
      *
           MOVE '0222' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'WASHINGTON B-DY' TO BLURB (1).
           MOVE ' (TRADITIONAL)' TO BLURB (2).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    WASHINGTON'S BIRTHDAY(OBSERVED) IS THE MONDAY IN THE
      *    WEEK OF FEBRUARY 22ND
      *
           PERFORM FIND-MONDAY-HOLIDAY.
           MOVE 'WASHINGTON B-DY' TO BLURB (1).
           MOVE '  (OBSERVED)' TO BLURB (2).
           IF (JULIAN-DAY NOT = JULIAN-HOLD)
               PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT
                   ELSE
               MOVE SPACES TO CALENDAR-CARD.
      *
      *    ST. PATRICK'S DAY IS MARCH 17TH
      *
           MOVE '0317' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'ST PATRICKS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    MOTHER'S DAY IS THE SECOND SUNDAY IN MAY
      *
           MOVE 5 TO SAVE-MO.
           MOVE 1 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           ADD 7 TO JULIAN-DAY.
           MOVE 'MOTHERS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    ARMED FORCES DAY IS THE THIRD SATURDAY IN MAY
      *
           MOVE 5 TO SAVE-MO.
           MOVE 7 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           ADD 14 TO JULIAN-DAY.
           MOVE 'ARMED FORCES' TO BLURB (1).
           MOVE '    DAY' TO BLURB (2).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    MEMORIAL DAY (TRADITIONAL) IS MAY 30TH.
      *
           MOVE '0530' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'MEMORIAL DAY' TO BLURB (1).
           MOVE '(TRADITIONAL)' TO BLURB (2).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    MEMORIAL DAY(OBSERVED) IS THE MONDAY IN THE WEEK OF
      *    MAY 30TH
      *
           MOVE 'MEMORIAL DAY' TO BLURB (1).
           MOVE ' (OBSERVED)' TO BLURB (2).
           PERFORM FIND-MONDAY-HOLIDAY.
           IF (JULIAN-DAY NOT = JULIAN-HOLD)
               PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT
                   ELSE
               MOVE SPACES TO CALENDAR-CARD.
      *
      *    FLAG DAY IS JUNE 14TH
      *
           MOVE '0614' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'FLAG DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    CHILDREN'S DAY IS THE SECOND SUNDAY IN JUNE
      *
           MOVE 6 TO SAVE-MO.
           MOVE 1 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           ADD 7 TO JULIAN-DAY.
           MOVE 'CHILDRENS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    FATHER'S DAY IS THE THIRD SUNDAY IN JUNE
      *
           MOVE 6 TO SAVE-MO.
           MOVE 1 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           ADD 14 TO JULIAN-DAY.
           MOVE 'FATHERS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    INDEPENDENCE DAY IS JULY 4TH
      *
           MOVE '0704' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'INDEPENDENCE DY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    LABOR DAY IS THE FIRST MONDAY IN SEPTEMBER
      *
           MOVE 9 TO SAVE-MO.
           MOVE 2 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           MOVE 'LABOR DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    COLUMBUS DAY (TRADITIONAL) IS OCTOBER 12TH
      *
           MOVE '1012' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'COLUMBUS DAY' TO BLURB (1).
           MOVE '(TRADITIONAL)' TO BLURB (2).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    COLUMBUS DAY (OBSERVED) IS THE MONDAY IN THE WEEK OF
      *    OCTOBER 12TH
      *
           MOVE 'COLUMBUS DAY' TO BLURB (1).
           MOVE ' (OBSERVED)' TO BLURB (2).
           PERFORM FIND-MONDAY-HOLIDAY.
           IF (JULIAN-DAY NOT = JULIAN-HOLD)
               PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT
                   ELSE
               MOVE SPACES TO CALENDAR-CARD.
      *
      *    ELECTION DAY IS THE 1ST TUESDAY AFTER THE 1ST MONDAY IN
      *    NOVEMBER
      *
           MOVE 11 TO SAVE-MO.
           MOVE 2 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           ADD 1 TO JULIAN-DAY.
           MOVE 'ELECTION DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    VETERAN'S DAY IS NOVEMBER 11TH
      *
           MOVE '1111' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'VETERANS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    THANKSGIVING DAY IS THE 4TH THURSDAY IN NOVEMBER
      *
           MOVE 11 TO SAVE-MO.
           MOVE 5 TO SAVE-WEEKDAY.
           PERFORM FIND-FIRST-WHATEVER THRU FIRST-WHATEVER-EXIT.
           ADD 21 TO JULIAN-DAY.
           MOVE 'THANKSGIVING DY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
      *
      *    CHRISTMAS IS ON DECEMBER 25TH
      *
           MOVE '1225' TO MONTH-DAY.
           PERFORM GREG-TO-JUL THRU GREG-TO-JUL-EXIT.
           MOVE 'CHRISTMAS DAY' TO BLURB (1).
           PERFORM RELEASE-HOLIDAY THRU HOLIDAY-EXIT.
           GO TO READ-LOOP.
       FIND-MONDAY-HOLIDAY.
           MOVE JULIAN-DAY TO JULIAN-HOLD.
           PERFORM FIND-DAY-OF-WEEK.
           IF (WEEKDAY < 2)
               SUBTRACT 6 FROM JULIAN-DAY
                   ELSE
               COMPUTE JULIAN-DAY =
               (JULIAN-DAY - (WEEKDAY - 2)).
       FIND-FIRST-WHATEVER.
           MOVE LOW-MONTH (SAVE-MO) TO JULIAN-DAY.
       FIRST-WHATEVER-LOOP.
           PERFORM FIND-DAY-OF-WEEK.
           IF  (WEEKDAY = SAVE-WEEKDAY) OR
               (JULIAN-DAY > HIGH-MONTH (SAVE-MO))
                   GO TO FIRST-WHATEVER-EXIT
                       ELSE
                   ADD 1 TO JULIAN-DAY
                   GO TO FIRST-WHATEVER-LOOP.
       FIRST-WHATEVER-EXIT.
           EXIT.
       READ-LOOP.
           READ CARDIN
               AT END GO TO END-CARDIN.
           IF MONTH-DAY NOT NUMERIC
               GO TO READ-LOOP.
           IF MONTH-DAY = '9999'
               GO TO POSTSCRIPT-CARD.
           ADD 1 TO CARDS-IN.
       GREG-TO-JUL.
           MOVE MH TO MO.
           MOVE DA TO DY.
           MOVE ZERO TO S1.
       GREGORIAN-TO-JULIAN.
           MOVE ZERO TO JULIAN-DAY.
           IF (MO < 1 OR > 12)
               GO TO GREG-TO-JUL-EXIT.
           COMPUTE S3 = ((HIGH-MONTH (MO) - LOW-MONTH (MO)) + 1).
           IF (DY > S3 OR = 0)
               GO TO GREG-TO-JUL-EXIT.
           COMPUTE JULIAN-DAY = ((LOW-MONTH (MO) + DY) - 1).
       GREG-TO-JUL-EXIT.
           EXIT.
       JUL-DAY-CHECK.
           IF (JULIAN-DAY = ZERO)
               GO TO INVALID-DATE.
       RELEASE-LOOP.
           ADD 1 TO S1.
           IF (S1 > 4)
               GO TO READ-LOOP.
           IF (BLURB (S1) = SPACES)
               GO TO RELEASE-LOOP.
           MOVE JULIAN-DAY TO SORT-JULIAN-DAY.
           MOVE S1 TO SORT-ORDER-FLAG.
           MOVE CARDS-IN TO SORT-CARD-IN.
           MOVE BLURB (S1) TO SORT-BLURB.
           PERFORM RELEASE-SORT-RECORD.
           GO TO RELEASE-LOOP.
       RELEASE-SORT-RECORD.
           RELEASE SORT-RECORD.
       RELEASE-HOLIDAY.
           ADD 1 TO CARDS-IN.
           MOVE 0 TO S1.
       HOLIDAY-LOOP.
           ADD 1 TO S1.
           IF (S1 > 4)
               GO TO HOLIDAY-EXIT.
           IF (BLURB (S1) = SPACES)
               GO TO HOLIDAY-LOOP.
           MOVE S1 TO SORT-ORDER-FLAG.
           MOVE JULIAN-DAY TO SORT-JULIAN-DAY.
           MOVE CARDS-IN TO SORT-CARD-IN.
           MOVE BLURB (S1) TO SORT-BLURB.
           IF (JULIAN-DAY > 0)
               PERFORM RELEASE-SORT-RECORD.
           GO TO HOLIDAY-LOOP.
       HOLIDAY-EXIT.
           MOVE SPACES TO CALENDAR-CARD.
       FIND-DAY-OF-WEEK.
      *    COMPUTE WEEKDAY = (((((((JULIAN-YEAR - 1) DIV 4) OLD BURROS
      *        + JULIAN-YEAR) MOD 7) + JULIAN-DAY) MOD 7) + 1).   CODE
           COMPUTE S11 = SAVE-FIRST-DAY - 1 + JULIAN-DAY.
      *    DIVIDE S11 BY 7 GIVING S12 REMAINDER WEEKDAY.  OLD IBM CODE
           DIVIDE S11 BY 7 GIVING S12.
           COMPUTE WEEKDAY = S11 - (S12 * 7).
           IF  WEEKDAY < 1
               MOVE 7 TO WEEKDAY.
       INVALID-DATE.
           MOVE CALENDAR-CARD TO INV-CARD.
           WRITE PRINTOUT-RECORD FROM INV-DATE-MSG AFTER 1 LINES.
           GO TO READ-LOOP.
       POSTSCRIPT-CARD.
           IF  LEFT-RIGHT > 2
               ADD 1 TO PS-SUB
               MOVE 1 TO LEFT-RIGHT.
           IF  PS-SUB > PS-MAX
               GO TO READ-LOOP.
           MOVE CARD-TEXT TO POSTSCRIPT (PS-SUB, LEFT-RIGHT).
           ADD 1 TO LEFT-RIGHT
           GO TO READ-LOOP.
       END-CARDIN.
           MOVE LOW-MONTH (1) TO SORT-JULIAN-DAY.
           MOVE 1 TO SORT-ORDER-FLAG.
           MOVE 9999 TO SORT-CARD-IN.
           MOVE SPACES TO SORT-BLURB.
           RELEASE SORT-RECORD.
           MOVE HIGH-MONTH (12) TO SORT-JULIAN-DAY.
           MOVE 1 TO SORT-ORDER-FLAG.
           MOVE 9999 TO SORT-CARD-IN.
           MOVE SPACES TO SORT-BLURB.
           RELEASE SORT-RECORD.
           CLOSE CARDIN.
       OUTPUT-PROCEDURE SECTION.
       WRITE-REPORT.
           MOVE SPACES TO PRINTOUT-RECORD.
           WRITE PRINTOUT-RECORD AFTER ADVANCING PAGE.
           MOVE SPACES TO PRINTOUT-RECORD.
           WRITE PRINTOUT-RECORD AFTER 3 LINES.
           MOVE YR-LINE TO HOLD-WORD-ARRAY.
           PERFORM PRINT-OUT-CHAR-MATRIX THRU MATRIX-EXIT.
           MOVE SPACES TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE 2 TIMES.
           MOVE '      CALENDAR      ' TO HOLD-WORD-ARRAY.
           PERFORM PRINT-OUT-CHAR-MATRIX THRU MATRIX-EXIT.
           MOVE SPACES TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE 2 TIMES.
           IF (HOLD-NAME = SPACES)
               GO TO OUTPUT-HOUSEKEEPING.
           MOVE '        FOR         ' TO HOLD-WORD-ARRAY.
           PERFORM PRINT-OUT-CHAR-MATRIX THRU MATRIX-EXIT.
           MOVE SPACES TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE 2 TIMES.
           MOVE HOLD-NAME TO HOLD-WORD-ARRAY.
           PERFORM PRINT-OUT-CHAR-MATRIX THRU MATRIX-EXIT.
       OUTPUT-HOUSEKEEPING.
           MOVE SPACES TO STORE-AREA.
           MOVE 1 TO S2, JULIAN-DAY, CURRENT-JULIAN-DAY.
           MOVE 1 TO SAVE-MO.
           MOVE 1 TO MO-SUB.
           PERFORM NEW-MONTH.
       COMPUTE-DAY-OF-WEEK.
      *    COMPUTE WEEKDAY = (((((((JULIAN-YEAR - 1) DIV 4)  BURROUGHS
      *        + JULIAN-YEAR) MOD 7) + JULIAN-DAY) MOD 7) + 1).  OLD
      *    COMPUTE S1 = (WEEKDAY MOD 8).                         CODE
           COMPUTE S11 = SAVE-FIRST-DAY - 1 + JULIAN-DAY.
      *    DIVIDE S11 BY 7 GIVING S12 REMAINDER WEEKDAY. OLD IBM CODE
           DIVIDE S11 BY 7 GIVING S12.
           COMPUTE WEEKDAY = S11 - (S12 * 7).
           IF  WEEKDAY < 1
               MOVE 7 TO WEEKDAY.
      *    DIVIDE WEEKDAY BY 8 GIVING S11 REMAINDER S1.  OLD IBM CODE
           DIVIDE WEEKDAY BY 8 GIVING S11.
           COMPUTE S1 = WEEKDAY - (S11 * 8).
       RETURN-SORTFILE-RECORD.
           RETURN SORTFILE RECORD
               AT END GO TO END-SORT-RECORDS.
       COMPARE-DAYS.
           IF (CURRENT-JULIAN-DAY < SORT-JULIAN-DAY)
               GO TO NEXT-DAY-PLEASE.
           IF (S2 > MAX-LINES-IN-BOX)
               GO TO RETURN-SORTFILE-RECORD.
           PERFORM CALCULATE-DAY-NUMBER.
           MOVE DAY-LINE TO STORE-BLURB (S1, 1).
           ADD 1 TO S2.
           MOVE SORT-BLURB TO STORE-BLURB (S1, S2).
           GO TO RETURN-SORTFILE-RECORD.
       JULIAN-TO-GREGORIAN.
           MOVE ZERO TO S3, DATE-HOLD.
       JUL-TO-GREG-LOOP.
           ADD 1 TO S3.
           IF (S3 > 12)
               GO TO JUL-TO-GREG-EXIT.
           IF (JULIAN-DAY < LOW-MONTH (S3) OR > HIGH-MONTH (S3))
               GO TO JUL-TO-GREG-LOOP.
           MOVE JULIAN-YEAR TO YR.
           MOVE S3 TO MO, MO-SUB.
           COMPUTE DY = (JULIAN-DAY - LOW-MONTH (S3) + 1).
       JUL-TO-GREG-EXIT.
           EXIT.
       NEXT-DAY-PLEASE.
           ADD 1 TO S1.
           IF (S1 > 7)
               PERFORM WRITE-7-DAYS-WORTH
               MOVE 0 TO S1
               GO TO NEXT-DAY-PLEASE.
           ADD 1 TO CURRENT-JULIAN-DAY.
           PERFORM CALCULATE-DAY-NUMBER.
           IF (MO > SAVE-MO) AND (S1 = 1)
               PERFORM NEW-MONTH.
           IF (MO > SAVE-MO) AND (S1 > 1)
               PERFORM WRITE-7-DAYS-WORTH
               PERFORM WRITE-POSTSCRIPTS
               PERFORM NEW-MONTH.
           MOVE DAY-LINE TO STORE-BLURB (S1, 1).
           MOVE 1 TO S2.
           MOVE MO TO SAVE-MO.
           GO TO COMPARE-DAYS.
       CALCULATE-DAY-NUMBER.
           MOVE CURRENT-JULIAN-DAY TO JULIAN-DAY.
           PERFORM JULIAN-TO-GREGORIAN THRU JUL-TO-GREG-EXIT.
           MOVE DY TO DY-NO.
       WRITE-7-DAYS-WORTH.
           PERFORM WRITE-LINES-DOWN
               VARYING S3 FROM 1 BY 1
                   UNTIL (S3 > MAX-LINES-IN-BOX).
           MOVE CALENDAR-LINE-1 TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE.
           MOVE SPACES TO STORE-AREA.
       WRITE-LINES-DOWN.
           PERFORM MOVE-BLURBS
               VARYING S4 FROM 1 BY 1
                   UNTIL (S4 > 7).
           MOVE CALENDAR-LINE-2 TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE.
       MOVE-BLURBS.
           MOVE STORE-BLURB (S4, S3) TO LINE-2 (S4).
           MOVE VERT-BAR TO EDGE-2 (S4).
           MOVE SPACES TO FILLER-2A (S4)
                          FILLER-2B (S4).
       WRITE-LINE.
           IF  PRINT-FLAG = 'Y'
               WRITE PRINTOUT-RECORD AFTER 1 LINES.
       WRITE-POSTSCRIPTS.
           MOVE SPACES TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE.
           PERFORM POSTSCRIPT-MOVE-N-PRINT
               VARYING S10 FROM 1 BY 1
               UNTIL S10 > PS-SUB.
       POSTSCRIPT-MOVE-N-PRINT.
           MOVE POSTSCRIPTS (S10) TO PRINTOUT-TEXT.
           PERFORM WRITE-LINE.
       NEW-MONTH.
           MOVE SPACES TO PRINTOUT-RECORD.
           IF  HOLD-MONTH NOT NUMERIC OR HOLD-MONTH = MO-SUB
               MOVE 'Y' TO PRINT-FLAG
               WRITE PRINTOUT-RECORD AFTER ADVANCING PAGE
               PERFORM EXTRA-PAGE
                   ELSE
               MOVE 'N' TO PRINT-FLAG.
           MOVE MO-NAME (MO-SUB) TO HOLD-WORD-ARRAY.
           INSPECT HOLD-WORD-ARRAY
               REPLACING ALL '&'
               BY SPD-1.
           INSPECT HOLD-WORD-ARRAY
               REPLACING ALL '*'
               BY SPD-2.
           INSPECT HOLD-WORD-ARRAY
               REPLACING ALL '('
               BY SPD-3.
           INSPECT HOLD-WORD-ARRAY
               REPLACING ALL ')'
               BY SPD-4.
           IF  PRINT-FLAG = 'Y'
               PERFORM PRINT-OUT-CHAR-MATRIX THRU MATRIX-EXIT.
           MOVE SPACES TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE 2 TIMES.
           MOVE DAYS-OF-WEEK TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE.
           MOVE CALENDAR-LINE-1 TO PRINTOUT-RECORD.
           PERFORM WRITE-LINE.
       EXTRA-PAGE.
           IF HOLD-EXTRA-PAGE-FLAG = 'Y'
               MOVE SPACES TO PRINTOUT-RECORD
               WRITE PRINTOUT-RECORD AFTER ADVANCING PAGE.
       END-SORT-RECORDS.
           PERFORM WRITE-7-DAYS-WORTH.
           PERFORM WRITE-POSTSCRIPTS.
           CLOSE PRINTOUT.
           GO TO MATRIX-EXIT.
       OUTPUT-PROCEDURE-EXIT SECTION.
       PRINT-OUT-CHAR-MATRIX.
           MOVE 0 TO S10.
           PERFORM MOVE-IN-COMBOS THRU COMBO-EXIT.
           PERFORM PRINT-LINES-DOWN
               VARYING S10 FROM 1 BY 1
                   UNTIL (S10 > 7).
      *    MOVE SPACES TO PRINTOUT-RECORD.
      *    WRITE PRINTOUT-RECORD AFTER 2 LINES.
           GO TO MATRIX-EXIT.
       MOVE-IN-COMBOS.
           ADD 1 TO S10.
           IF (S10 > 20)
               GO TO COMBO-EXIT.
           MOVE 0 TO S11.
           MOVE 1 TO S12.
           PERFORM CHECK-ALL-COMBOS THRU ALL-COMBOS-EXIT.
           PERFORM MOVE-IN-LETTER-COMBOS
               VARYING S11 FROM 1 BY 1
                   UNTIL (S11 > 7).
           GO TO MOVE-IN-COMBOS.
       COMBO-EXIT.
           EXIT.
       CHECK-ALL-COMBOS.
           ADD 1 TO S11.
           IF (S11 > 40)
               GO TO ALL-COMBOS-EXIT.
           IF (H-CHAR (S10) = CHAR-CK (S11))
              MOVE S11 TO S12
              GO TO ALL-COMBOS-EXIT
                  ELSE
              GO TO CHECK-ALL-COMBOS.
       ALL-COMBOS-EXIT.
           EXIT.
       MOVE-IN-LETTER-COMBOS.
           MOVE MAT-CHAR (S12, S11) TO HOLD-KEY (S10, S11).
       PRINT-LINES-DOWN.
           MOVE SPACES TO PRINTOUT-RECORD.
           PERFORM FILL-IN-LINES-ACROSS
               VARYING S11 FROM 1 BY 1
                   UNTIL (S11 > 20).
           WRITE PRINTOUT-RECORD AFTER 1 LINES.
       FILL-IN-LINES-ACROSS.
           MOVE HOLD-KEY (S11, S10) TO S12.
           MOVE COMBO (S12) TO LINE-CHAR (S11).
       MATRIX-EXIT.
           EXIT.


