       IDENTIFICATION DIVISION.
       PROGRAM-ID. MAINTAIN.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.                                                     
       INPUT-OUTPUT SECTION.                                              
       FILE-CONTROL.                                                      
           SELECT MASTER-FILE          ASSIGN TO DISK
                                       FILE STATUS IS FILE-STAT
                                       ACCESS MODE IS DYNAMIC
                                       ORGANIZATION IS INDEXED
                                       RECORD KEY IS OURSTUFF-KEY.
                                                                          
       DATA DIVISION.                                                     
       FILE SECTION.

       FD  MASTER-FILE                                                     
           LABEL RECORDS ARE STANDARD
           VALUE OF FILE-ID IS "OURSTUFF.DAT".
       COPY OURSTUFF.CPY.

       WORKING-STORAGE SECTION.

       77  SUB1                            PIC 9(3) COMP-3  VALUE ZERO.
       77  SUB2                            PIC 9(3) COMP-3  VALUE ZERO.
       77  PRIOR-KEY                       PIC X(06)        VALUE SPACE.

       COPY CATEGORY.CPY.

       COPY FUNCTION.CPY.

       01  FILE-STAT                       PIC X(02).
       01  END-OF-FILE-FLAG                PIC X(01)        VALUE "N".
           88  END-OF-FILE                                  VALUE "Y".

       01  MISC-FIELDS.
           05  MISC-DATE.
               10  MD-YY                   PIC X(02).
               10  MD-MM                   PIC X(02).
               10  MD-DD                   PIC X(02).
           05  MISC-TIME.
               10  MT-HH                   PIC X(02).
               10  MT-MM                   PIC X(02).
               10  MT-SS                   PIC X(02).
           05  FORMATTED-DATE.
               10  FD-MM                   PIC X(02).
               10  FILLER                  PIC X(01)       VALUE "/".
               10  FD-DD                   PIC X(02).
               10  FILLER                  PIC X(01)       VALUE "/".
               10  FD-YY                   PIC X(02).
           05  FORMATTED-TIME.
               10  FT-HH                   PIC X(02).
               10  FILLER                  PIC X(01)       VALUE ":".
               10  FT-MM                   PIC X(02).

       01  WORK-RECORD.
           05  WORK-KEY.
               10  WORK-KEY-PREFIX         PIC X(03).
               10  WORK-KEY-SUFFIX         PIC X(03).
           05  WORK-LOCATION               PIC X(12).
           05  WORK-PURCHASE-DATE          PIC X(06).
           05  WORK-PURCHASE-PRICE         PIC 9(06).
           05  WORK-DESCRIPTION            PIC X(50).

       01  CASE-WORKAREA.
           05  CASE-CHAR                   OCCURS 50 TIMES  PIC X.

       01  DEBUGGING-MESSAGE               PIC X(40) VALUE SPACES.

       01  LOWER-CASE-ARRAY.
           05  LOWER-CASE                  PIC X(26) VALUE
           "abcdefghijklmnopqrstuvwxyz".
           05  LOWER-CASE-CHAR             REDEFINES LOWER-CASE
                                           OCCURS 26 TIMES  PIC X.
                                           
       01  UPPER-CASE-ARRAY.
           05  UPPER-CASE                  PIC X(26) VALUE
           "ABCDEFGHIJKLMNOPQRSTUVWXYZ".
           05  UPPER-CASE-CHAR             REDEFINES UPPER-CASE
                                           OCCURS 26 TIMES  PIC X.
       SCREEN SECTION.         
       
       01  SCREEN1-ADDRESS-ENTRY.
      *    05  BLANK SCREEN BACKGROUND-COLOR 1 FOREGROUND-COLOR 15.
           05  BLANK SCREEN.
           05  LINE 1   COLUMN  1      FOREGROUND-COLOR 11
                                       PIC X(08)
                                       FROM FORMATTED-DATE.
           05  LINE 1   COLUMN 15      FOREGROUND-COLOR 2
               VALUE "H O M E    I N V E N T O R Y".
           05  LINE 1   COLUMN 47      FOREGROUND-COLOR 2
               VALUE "M A I N T E N A N C E".
           05  LINE 1   COLUMN 76      FOREGROUND-COLOR 11
                                       PIC X(05)
                                       FROM FORMATTED-TIME.
           05  LINE 4  COLUMN  3       FOREGROUND-COLOR 14
                                       VALUE "KEY (CATEGORY/SEQUENCE):".
           05  SCREEN1-KEY             LINE 4  COLUMN 28                 
                                       PIC X(06)                         
                                       REVERSE-VIDEO                     
                                       USING WORK-KEY.      
           05  LINE 6  COLUMN 18       FOREGROUND-COLOR 14                         
                                       VALUE "LOCATION:".                  
           05  SCREEN1-LOCATION        LINE 6  COLUMN 28                 
                                       PIC X(12)                         
                                       REVERSE-VIDEO                     
                                       USING WORK-LOCATION.    
           05  LINE 8 COLUMN 13        FOREGROUND-COLOR 14                         
                                       VALUE "ACQUIRED DATE:".              
           05  SCREEN1-PURCHASE-DATE   LINE 8  COLUMN 28                 
                                       PIC X(06)                         
                                       REVERSE-VIDEO                     
                                       USING WORK-PURCHASE-DATE.
           05  LINE 8 COLUMN 35        FOREGROUND-COLOR 14                         
                                       VALUE "(MONTH/DAY/YEAR)".              
           05  LINE 10 COLUMN 12       FOREGROUND-COLOR 14
                                       VALUE "ACQUIRED PRICE:".
           05  SCREEN1-PURCHASE-PRICE  LINE 10 COLUMN 28
                                       PIC 9(06)
                                       REVERSE-VIDEO
                                       USING WORK-PURCHASE-PRICE.
           05  LINE 10 COLUMN 35       FOREGROUND-COLOR 14
                                       VALUE "(WHOLE DOLLARS)".
           05  LINE 12 COLUMN 15       FOREGROUND-COLOR 14
                                       VALUE "DESCRIPTION:".
           05  SCREEN1-DESCRIPTION     LINE 12 COLUMN 28
                                       PIC X(50)
                                       REVERSE-VIDEO
                                       USING WORK-DESCRIPTION.
           05  LINE 21 COLUMN 16       FOREGROUND-COLOR 14
                                       VALUE "MESSAGE(S): ".
           05  LINE 21 COLUMN 28       FOREGROUND-COLOR 11
                                       PIC X(40)
                                       FROM  DEBUGGING-MESSAGE.

      * 01  FUNC-KEYS.
           05  LINE 23 COLUMN 2        FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F1  ".  
           05  LINE 23 COLUMN 10       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F2  ".  
           05  LINE 23 COLUMN 18       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F3  ".  
           05  LINE 23 COLUMN 26       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F4  ".  
           05  LINE 23 COLUMN 34       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F5  ".  
           05  LINE 23 COLUMN 42       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F6  ".  
           05  LINE 23 COLUMN 50       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F7  ".  
           05  LINE 23 COLUMN 58       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F8  ".  
           05  LINE 23 COLUMN 66       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F9  ".  
           05  LINE 23 COLUMN 74       FOREGROUND-COLOR 12
                                       BACKGROUND-COLOR 8
                                       VALUE "  F10 ".  


           05  LINE 24 COLUMN 2        FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 10       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "SCROLL".
           05  LINE 24 COLUMN 18       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 26       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 34       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 42       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 50       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 58       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 66       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 24 COLUMN 74       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".

           05  LINE 25 COLUMN 2        FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 25 COLUMN 10       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "  FWD ".
           05  LINE 25 COLUMN 18       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "  END ".
           05  LINE 25 COLUMN 26       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE " FIND ".
           05  LINE 25 COLUMN 34       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE " RESET".
           05  LINE 25 COLUMN 42       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "  ADD ".
           05  LINE 25 COLUMN 50       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 25 COLUMN 58       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "UPDATE".
           05  LINE 25 COLUMN 66       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "      ".
           05  LINE 25 COLUMN 74       FOREGROUND-COLOR 10
                                       BACKGROUND-COLOR 8
                                       VALUE "DELETE".


       01  SCREEN-BLANK.
           05  BLANK SCREEN BACKGROUND-COLOR 0 FOREGROUND-COLOR 7.

       PROCEDURE DIVISION.
       C000-MAIN-LINE SECTION. 
       
       A100-MAIN-LINE-LOGIC.

           MOVE 98 TO FUNCTION-KEY-PRESSED, PRIOR-FUNCTION-KEY-PRESSED.
           OPEN I-O MASTER-FILE.
           MOVE  SPACES                    TO  OURSTUFF-RECORD.
           MOVE  ZERO                      TO  OURSTUFF-PURCHASE-PRICE.
           PERFORM G100-DISPLAY-NEW-SCREEN THRU G199-EXIT.
           PERFORM C100-PROCESS-KEYBOARD-REQUEST THRU C199-EXIT
               UNTIL F3.
           DISPLAY SCREEN-BLANK.
           CLOSE MASTER-FILE.
           STOP RUN.




       C100-PROCESS-KEYBOARD-REQUEST.

           MOVE  SPACES                    TO  DEBUGGING-MESSAGE.
           ACCEPT ( 4, 28 )
                  WORK-KEY.
           ACCEPT FUNCTION-KEY-PRESSED FROM ESCAPE KEY.
           IF  F3
               GO TO C199-EXIT.
      *
      *    TRANSFORM WORK-KEY FROM LOWER CASE TO UPPER CASE.
      *    (TOO BAD TRANSFORM VERB ISN'T IMPLEMENTED IN THIS COMPILER)
      *
           MOVE  WORK-KEY                  TO  CASE-WORKAREA.
           PERFORM E100-LOWER-TO-UPPER THRU E199-EXIT
               VARYING SUB1 FROM 1 BY 1
               UNTIL SUB1 > 50.
           MOVE  CASE-WORKAREA             TO  WORK-KEY.

           IF  F2
               PERFORM D200-READ-NEXT THRU D299-EXIT
               GO TO C199-EXIT.

           IF  F4
               PERFORM D400-READ-RANDOM THRU D499-EXIT
               GO TO C199-EXIT.

           IF  F5
               PERFORM D500-RESET THRU D599-EXIT
               GO TO C199-EXIT.

           IF  F6
               PERFORM D600-ADD THRU D699-EXIT
               GO TO C199-EXIT.

           IF  F8
               PERFORM D800-UPDATE THRU D899-EXIT
               GO TO C199-EXIT.

           IF  F10
               PERFORM D1000-DELETE THRU D1099-EXIT
               GO TO C199-EXIT.

           MOVE "INVALID FUNCTION KEY PRESSED" TO DEBUGGING-MESSAGE.
           MOVE  PRIOR-KEY                     TO WORK-KEY.
           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       C199-EXIT.

           MOVE  FUNCTION-KEY-PRESSED  TO  PRIOR-FUNCTION-KEY-PRESSED.




       D200-READ-NEXT.

           IF  PRIOR-F2 AND FILE-STAT = "00" AND WORK-KEY = SPACES
               NEXT SENTENCE
           ELSE
               PERFORM R200-START THRU R299-EXIT.

       D250-READ-NEXT.

           PERFORM R300-READ-NEXT THRU R399-EXIT.

           IF  NOT END-OF-FILE
               PERFORM G200-DATABASE-TO-SCREEN THRU G299-EXIT
               MOVE  OURSTUFF-KEY          TO  PRIOR-KEY.

           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       D299-EXIT.

           EXIT.




       D400-READ-RANDOM.

           PERFORM R100-READ-RANDOM THRU R199-EXIT.
           IF  FILE-STAT = "00"
               PERFORM G200-DATABASE-TO-SCREEN THRU G299-EXIT
               MOVE  OURSTUFF-KEY          TO  PRIOR-KEY.

           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       D499-EXIT.

           EXIT.




       D500-RESET.

           MOVE  SPACES                    TO  PRIOR-KEY.
           PERFORM G100-DISPLAY-NEW-SCREEN THRU G199-EXIT.

       D599-EXIT.

           EXIT.




       D600-ADD.

           SET CAT-IDX                            TO  1.
           SEARCH  CATEGORIES                     VARYING CAT-IDX
               AT END
                   MOVE "INVALID KEY CATEGORY" TO DEBUGGING-MESSAGE
                   GO TO D680-DISPLAY-SCREEN
               WHEN CATEGORY (CAT-IDX) = WORK-KEY-PREFIX
                   NEXT SENTENCE.

           IF  WORK-KEY-SUFFIX NOT NUMERIC
               MOVE  "KEY SEQUENCE NOT NUMERIC"   TO  DEBUGGING-MESSAGE
               GO TO D680-DISPLAY-SCREEN.

           PERFORM E200-ACCEPT-SCREEN-INFO THRU E299-EXIT.

           IF  WORK-PURCHASE-DATE NOT NUMERIC
               MOVE  "ACQUIRED DATE NOT NUMERIC"  TO  DEBUGGING-MESSAGE
               GO TO D680-DISPLAY-SCREEN.

           ACCEPT FUNCTION-KEY-PRESSED FROM ESCAPE KEY.

           IF  ESC
               MOVE  "ADD CANCELLED"       TO  DEBUGGING-MESSAGE
               GO TO D680-DISPLAY-SCREEN.
           
           MOVE  "RECORD ADDED"            TO  DEBUGGING-MESSAGE.
           PERFORM G300-SCREEN-TO-DATABASE THRU G399-EXIT.
           PERFORM S100-ADD THRU S199-EXIT.

       D680-DISPLAY-SCREEN.

           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       D699-EXIT.

           EXIT.




       D800-UPDATE.

           MOVE  PRIOR-KEY                 TO  WORK-KEY.
           PERFORM R100-READ-RANDOM THRU R199-EXIT.

           SET CAT-IDX                            TO  1.
           SEARCH  CATEGORIES                     VARYING CAT-IDX
               AT END
                   MOVE "INVALID KEY CATEGORY" TO DEBUGGING-MESSAGE
                   GO TO D880-DISPLAY-SCREEN
               WHEN CATEGORY (CAT-IDX) = WORK-KEY-PREFIX
                   NEXT SENTENCE.

           IF  WORK-KEY-SUFFIX NOT NUMERIC
               MOVE  "KEY SEQUENCE NOT NUMERIC"   TO  DEBUGGING-MESSAGE
               GO TO D880-DISPLAY-SCREEN.

           PERFORM E200-ACCEPT-SCREEN-INFO THRU E299-EXIT.

           IF  WORK-PURCHASE-DATE NOT NUMERIC
               MOVE  "ACQUIRED DATE NOT NUMERIC"  TO  DEBUGGING-MESSAGE
               GO TO D880-DISPLAY-SCREEN.

           ACCEPT FUNCTION-KEY-PRESSED FROM ESCAPE KEY.

           IF  ESC
               MOVE  "UPDATE CANCELLED"    TO  DEBUGGING-MESSAGE
               GO TO D880-DISPLAY-SCREEN.
           
           MOVE  "RECORD UPDATED"          TO  DEBUGGING-MESSAGE.
           PERFORM G300-SCREEN-TO-DATABASE THRU G399-EXIT.
           PERFORM S200-REWRITE THRU S299-EXIT.

       D880-DISPLAY-SCREEN.

           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       D899-EXIT.

           EXIT.




       D1000-DELETE.

           IF  NOT PRIOR-F10
               MOVE "ARE YOU SURE? PRESS F10 AGAIN TO DELETE"
                   TO  DEBUGGING-MESSAGE
               GO TO D1080-DISPLAY-SCREEN.

           PERFORM S300-DELETE THRU S399-EXIT.

           MOVE "RECORD DELETED" TO DEBUGGING-MESSAGE.

       D1080-DISPLAY-SCREEN.

           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       D1099-EXIT.

           EXIT.




       E100-LOWER-TO-UPPER.

           IF  CASE-CHAR (SUB1) NOT < "A"
               PERFORM F100-TRANSFORM-CASE THRU F199-EXIT
                   VARYING SUB2 FROM 1 BY 1
                   UNTIL SUB2 > 26.

       E199-EXIT.

           EXIT.




       E200-ACCEPT-SCREEN-INFO.

           ACCEPT ( 6, 28 )                        WORK-LOCATION.
           IF  WORK-LOCATION = SPACES
               MOVE  OURSTUFF-LOCATION         TO  WORK-LOCATION.
           ACCEPT ( 8, 28 )                        WORK-PURCHASE-DATE.
           IF  WORK-PURCHASE-DATE = SPACES
               MOVE  OURSTUFF-PURCHASE-DATE    TO  WORK-PURCHASE-DATE. 
           ACCEPT ( 10, 28 )                       WORK-PURCHASE-PRICE.
           IF  WORK-PURCHASE-PRICE = ZERO
               MOVE  OURSTUFF-PURCHASE-PRICE   TO  WORK-PURCHASE-PRICE.
           ACCEPT ( 12, 28 )                       WORK-DESCRIPTION.
           IF  WORK-DESCRIPTION = SPACES
               MOVE  OURSTUFF-DESCRIPTION      TO  WORK-DESCRIPTION.

       E299-EXIT.

           EXIT.




       F100-TRANSFORM-CASE.

           IF  CASE-CHAR (SUB1) = LOWER-CASE-CHAR (SUB2)
               MOVE UPPER-CASE-CHAR (SUB2) TO CASE-CHAR (SUB1).

       F199-EXIT.

           EXIT.




       G100-DISPLAY-NEW-SCREEN.

           MOVE SPACES TO WORK-RECORD.
           MOVE ZERO TO WORK-PURCHASE-PRICE.
           PERFORM M100-DISPLAY-SCREEN1 THRU M199-EXIT.

       G199-EXIT.

           EXIT.




       G200-DATABASE-TO-SCREEN.

           MOVE  OURSTUFF-KEY              TO  WORK-KEY.
           MOVE  OURSTUFF-LOCATION         TO  WORK-LOCATION.
           MOVE  OURSTUFF-PURCHASE-DATE    TO  WORK-PURCHASE-DATE.
           MOVE  OURSTUFF-PURCHASE-PRICE   TO  WORK-PURCHASE-PRICE.
           MOVE  OURSTUFF-DESCRIPTION      TO  WORK-DESCRIPTION.

       G299-EXIT.

           EXIT.




       G300-SCREEN-TO-DATABASE.

           MOVE  WORK-KEY                  TO  OURSTUFF-KEY.
           MOVE  WORK-LOCATION             TO  OURSTUFF-LOCATION.
           MOVE  WORK-PURCHASE-DATE        TO  OURSTUFF-PURCHASE-DATE.
           MOVE  WORK-PURCHASE-PRICE       TO  OURSTUFF-PURCHASE-PRICE.
           MOVE  WORK-DESCRIPTION          TO  OURSTUFF-DESCRIPTION.

       G399-EXIT.

           EXIT.




       M100-DISPLAY-SCREEN1.

           ACCEPT  MISC-DATE               FROM  DATE.
           MOVE  MD-YY                     TO  FD-YY.
           MOVE  MD-MM                     TO  FD-MM.
           MOVE  MD-DD                     TO  FD-DD.
           ACCEPT  MISC-TIME               FROM  TIME.
           MOVE  MT-HH                     TO  FT-HH.
           MOVE  MT-MM                     TO  FT-MM.
           DISPLAY SCREEN1-ADDRESS-ENTRY.

       M199-EXIT.

           EXIT.




       R100-READ-RANDOM.

           MOVE WORK-KEY TO OURSTUFF-KEY.
           READ MASTER-FILE
               KEY IS OURSTUFF-KEY.
           IF  FILE-STAT = "23"
               MOVE  SPACES                TO  WORK-LOCATION
               MOVE  SPACES                TO  WORK-PURCHASE-DATE
               MOVE  ZEROES                TO  WORK-PURCHASE-PRICE
               MOVE  "RECORD NOT FOUND"    TO  DEBUGGING-MESSAGE
               GO TO R199-EXIT.
           IF  FILE-STAT NOT = "00"
               PERFORM V100-FILE-IO-ERROR THRU V199-EXIT.

       R199-EXIT.

           EXIT.




       R200-START.

           IF  WORK-KEY NOT = SPACES
               MOVE  WORK-KEY              TO  PRIOR-KEY.

           IF  PRIOR-F4 
               GO TO R250-START.
           MOVE  "N"                       TO  END-OF-FILE-FLAG.

           MOVE  WORK-KEY                  TO  OURSTUFF-KEY.
           START MASTER-FILE       KEY IS NOT LESS THAN OURSTUFF-KEY
               INVALID KEY
                   PERFORM V100-FILE-IO-ERROR THRU V199-EXIT
                   GO TO R299-EXIT.

       R250-START.

           MOVE  "N"                       TO  END-OF-FILE-FLAG.
           MOVE  PRIOR-KEY                  TO  OURSTUFF-KEY.
           START MASTER-FILE       KEY GREATER THAN OURSTUFF-KEY
               INVALID KEY
                   PERFORM V100-FILE-IO-ERROR THRU V199-EXIT.

       R299-EXIT.

           EXIT.




       R300-READ-NEXT.

           READ MASTER-FILE
               NEXT RECORD.
           IF  FILE-STAT = "10" OR "34"
               MOVE SPACES TO WORK-RECORD
               MOVE ZERO TO WORK-PURCHASE-PRICE
               MOVE  "END OF FILE REACHED" TO  DEBUGGING-MESSAGE
               MOVE  "Y" TO END-OF-FILE-FLAG
               MOVE  SPACES TO PRIOR-KEY
               GO TO R399-EXIT.
           IF  FILE-STAT NOT = "00"
               PERFORM V100-FILE-IO-ERROR THRU V199-EXIT.

       R399-EXIT.

           EXIT.




       S100-ADD.

           WRITE OURSTUFF-RECORD
             INVALID KEY
                 PERFORM V100-FILE-IO-ERROR THRU V199-EXIT.

       S199-EXIT.

           EXIT.




       S200-REWRITE.

           REWRITE OURSTUFF-RECORD
               INVALID KEY
                   PERFORM V100-FILE-IO-ERROR THRU V199-EXIT.

       S299-EXIT.

           EXIT.




       S300-DELETE.

           MOVE PRIOR-KEY TO OURSTUFF-KEY WORK-KEY.
           DELETE MASTER-FILE RECORD
               INVALID KEY PERFORM V100-FILE-IO-ERROR THRU V199-EXIT.

       S399-EXIT.

           EXIT.




       V100-FILE-IO-ERROR.

           STRING "FILE I/O ERROR ... FILE STATUS = " DELIMITED SIZE
                   FILE-STAT                          DELIMITED SIZE
               INTO DEBUGGING-MESSAGE.

       V199-EXIT.

           EXIT.

